unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, ExtCtrls, StdCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
  private
    FPicture: TPicture;

  public

  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

uses
  LCLIntf;

const
  fn = 'bild.jpg';

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
begin
  FPicture := TPicture.Create;
  FPicture.LoadFromFile(fn);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  FreeAndNil(FPicture);
end;

procedure TForm1.FormPaint(Sender: TObject);
var
  R: TRect;
  delta: Integer;
  wForm, hForm: Integer;
  wPic, hPic: Integer;
begin
  if FPicture = nil then
    exit;

  wForm := ClientWidth;
  hForm := ClientHeight;
  wPic := FPicture.Width;
  hPic := FPicture.Height;

  if (hForm / wForm < hPic / wPic) then
  begin
    R := Rect(0, 0, wForm, round(wForm / wPic * hPic));
    delta := (hForm - R.Height) div 2;
    OffsetRect(R, 0, delta);
  end else
  begin
    R := Rect(0, 0, round(hForm / hPic * wPic), hForm);
    delta := (wForm - R.Width) div 2;
    OffsetRect(R, delta, 0);
  end;
  Canvas.StretchDraw(R, FPicture.Graphic);
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  Invalidate;
end;

end.

